/*----------------------------------------------------------------------------

  SVG Susie Plugin
                                                  Copyright(C) fok@Bay-Side
  Plugin Interface Module

----------------------------------------------------------------------------*/
#include "stdafx.h"
#include "header.h"

/*----------------------------------------------------------------------------
	O[oϐ
----------------------------------------------------------------------------*/
std::basic_string<TCHAR> gstrCoreFile;
std::basic_string<TCHAR> gstrIniFile;
HINSTANCE ghInst;

/*----------------------------------------------------------------------------
	CGg|Cg
----------------------------------------------------------------------------*/
BOOL APIENTRY DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved)
{
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:

		ghInst = hInst;
		break;
	}

	return TRUE;
}

/*----------------------------------------------------------------------------
	Cu
----------------------------------------------------------------------------*/
static VOID InitSVGEngine()
{
	if(gstrCoreFile.empty())
	{
		// ̏ꏊ{ifsvg/ifsvg_core.exeRAGW
		TCHAR szFileName[MAX_PATH];
		GetModuleFileName(ghInst, szFileName, _countof(szFileName));
		PathRemoveFileSpec(szFileName);
		_tcscat_s(szFileName, _T("\\ifsvg\\ifsvg_core.exe"));
		if(PathFileExists(szFileName))
		{
			gstrCoreFile = szFileName;
		}

		// init@C̏ꏊ
		GetModuleFileName(ghInst, szFileName, _countof(szFileName));
		PathRenameExtension(szFileName, _T(".ini"));
		gstrIniFile = szFileName;
	}
}

/*----------------------------------------------------------------------------
	SVG[_[Ăяo
----------------------------------------------------------------------------*/
static bool CallSVGEngine(LPCTSTR lpszExePath, LPCTSTR lpszSVGFile, bool bHeaderOnly, HLOCAL& hLocalHeader_, HLOCAL& hLocalImage_)
{
	SECURITY_ATTRIBUTES sa;
	HANDLE hPipeRead, hPipeWrite;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	TCHAR szFilePath[MAX_PATH];
	TCHAR szCmdLine[MAX_PATH + 100];
	TCHAR szSVGFile[MAX_PATH + 100];

	// pCv쐬
	ZeroMemory(&sa, sizeof(sa));
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = TRUE;
	if(!CreatePipe(&hPipeRead, &hPipeWrite, &sa, 0))
	{
		return false;
	}

	// ݒǂݍ
	INT nBitCount = GetPrivateProfileInt(_T("ifsvg"), _T("BitCount"), 24, gstrIniFile.c_str());
	if(32 != nBitCount && 24 != nBitCount)
	{
		nBitCount = 24;
	}

	// Np[^
	ZeroMemory(&si, sizeof(si));
	ZeroMemory(&pi, sizeof(pi));
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	si.wShowWindow = SW_HIDE;
	si.hStdOutput = hPipeWrite;
	_tcscpy_s(szCmdLine, lpszExePath);
	PathQuoteSpaces(szCmdLine);

	// R}hCXCb`
	if(bHeaderOnly)
	{
		_tcscat_s(szCmdLine, _T(" /getinfo"));
	}
	if(32 == nBitCount)
	{
		_tcscat_s(szCmdLine, _T(" /32bit"));
	}
	_tcscat_s(szCmdLine, _T(" "));

	// SVGt@C
	_tcscpy_s(szSVGFile, lpszSVGFile);
	PathQuoteSpaces(szSVGFile);
	_tcscat_s(szCmdLine, szSVGFile);

	// [Nϐ
	DWORD dwImageTotal = 0;
	DWORD dwExit = 0;
	BYTE abyHeader[sizeof(BITMAPINFOHEADER)];
	BYTE abyBuffer[50000];
	DWORD dwRead = 0;
	DWORD dwTotalAvail = 0;
	DWORD dwReadTotal = 0;
	DWORD dwCurrent = 0;
	HLOCAL hLocalHeader = NULL;
	HLOCAL hLocalImage = NULL;
	LPBYTE lpImageCurrent = NULL;
	bool bReadHeader = false;
	bool bProcessExit = false;

	// wb_
	hLocalHeader = LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER));
	if(!hLocalHeader)
	{
		CloseHandle(hPipeRead);
		CloseHandle(hPipeWrite);
		return false;
	}
	BITMAPINFOHEADER& bmi = *LPBITMAPINFOHEADER(hLocalHeader);

	// vZX쐬
	_tcscpy_s(szFilePath, lpszExePath);
	PathRemoveFileSpec(szFilePath);
	if(CreateProcess(NULL, szCmdLine, NULL, NULL, TRUE, 0, NULL, szFilePath, &si, &pi))
	{
		while(true)
		{
			if(!bProcessExit)
			{
				if(!GetExitCodeProcess(pi.hProcess, &dwExit))
				{
					break;
				}
			}

			// pCv猋ʂǂݏo
			dwTotalAvail = 0;
			if(PeekNamedPipe(hPipeRead, NULL, 0, NULL, &dwTotalAvail, NULL))
			{
				if(dwTotalAvail == 0)
				{
					if(bProcessExit)
					{
						// ǂݍݏI
						break;
					}
				}
				else if(dwTotalAvail > 0)
				{
					dwRead = 0;
					if(ReadFile(hPipeRead, abyBuffer, sizeof(abyBuffer), &dwRead, NULL))
					{
						dwReadTotal += dwRead;

						if(!bReadHeader)
						{
							// wb_̓ǂݍ݂ĂȂ

							if(dwReadTotal >= sizeof(bmi))
							{
								// wb_ǂݍ݂
								CopyMemory(abyHeader + dwCurrent, abyBuffer, sizeof(bmi) - dwCurrent);
								CopyMemory(&bmi, abyHeader, sizeof(bmi));
								bReadHeader = true;

								if(!bHeaderOnly)
								{
									// ăC[Wǂݍ
									hLocalImage = LocalAlloc(LPTR, bmi.biSizeImage);
									if(!hLocalImage)
									{
										break;
									}
									lpImageCurrent = reinterpret_cast<LPBYTE>(hLocalImage);

									// obt@̗]
									DWORD dwRemain = dwRead - (sizeof(bmi) - dwCurrent);
									CopyMemory(lpImageCurrent, abyBuffer + (sizeof(bmi) - dwCurrent), dwRemain);
									lpImageCurrent += dwRemain;
								}
								else
								{
									// ŏIɂȂ
								}
							}
							else if(dwReadTotal < sizeof(bmi))
							{
								CopyMemory(abyHeader + dwCurrent, abyBuffer, dwRead);
							}
							dwCurrent += dwRead;
						}
						else
						{
							// wb_ǂݍ݊
							if(!bHeaderOnly)
							{
								// ǂ񂾂̂ubNɓĂ
								CopyMemory(lpImageCurrent, abyBuffer, dwRead);
								lpImageCurrent += dwRead;
							}
						}
					}
				}
			}
			else
			{
				if(bProcessExit)
				{
					// Ɏs炵
					break;
				}
			}

			if(!bProcessExit)
			{
				if(dwExit != STILL_ACTIVE)
				{
					// vZXI
					bProcessExit = true;
				}
			}
		}

		if(!bHeaderOnly)
		{
			dwImageTotal = DWORD_PTR(lpImageCurrent) - DWORD_PTR(hLocalImage);
		}
	}

	CloseHandle(hPipeRead);
	CloseHandle(hPipeWrite);

	if(!bHeaderOnly)
	{
		if(dwImageTotal != bmi.biSizeImage)
		{
			// [hs
			LocalFree(hLocalHeader);
			LocalFree(hLocalImage);
			return false;
		}
	}

	hLocalHeader_ = hLocalHeader;
	hLocalImage_ = hLocalImage;
	return true;
}

/*----------------------------------------------------------------------------
	APIFvOC擾
----------------------------------------------------------------------------*/
EXTERN_C INT WINAPI GetPluginInfo(INT nIndex, LPSTR szRetBuffer, INT nBufLength)
{
	INT nSize;
	LPCSTR apszPluginInfo[] =
	{
		/* 0 */     "00IN",
		/* 1 */     "SVG Plug-in Ver 1.00",
		/* 2n+1 */  "*.svg",
		/* 2n+2 */  "SVG Format (*.svg)",
	};

	if(nIndex < _countof(apszPluginInfo))
	{
		LPCSTR s = apszPluginInfo[nIndex];
		nSize = lstrlenA(s) + 1;
		nSize = (nSize < nBufLength) ? nSize : nBufLength;
		CopyMemory(szRetBuffer, apszPluginInfo[nIndex], nSize);
	}
	else
	{
		nSize = 0;
	}

	return nSize;
}

/*----------------------------------------------------------------------------
	APIFt@CT|[g`FbN
----------------------------------------------------------------------------*/
EXTERN_C BOOL WINAPI IsSupported(LPCSTR lpszFileName, DWORD dwFlag)
{
	InitSVGEngine();

	/*
	dwFlag:
	ʃ[h0		t@Cnh
	ʃ[h0		t@C擪(2Kbyteȏ)ǂݍ񂾃obt@ւ̃|C^B
						t@CTCY2Kbyteȉ̏ꍇobt@2KbytemۂA
						]0Ŗ߂邱ƁB
	*/

#if 0
	BYTE abyHeader[2000];
	if(HIWORD(dwFlag) == 0)
	{
		// dwFlag : t@Cnh
		DWORD dwRead = 0;
		ZeroMemory(abyHeader, sizeof(abyHeader));
		ReadFile((HANDLE)dwFlag, abyHeader, sizeof(abyHeader), &dwRead, NULL);
	}
	else
	{
		// dwFlag : obt@
		CopyMemory(abyHeader, (LPVOID)dwFlag, sizeof(lpHeader));
	}

	// wb_𒲂ׂ
	if(memcmp(lpHeader, "<?xml", 5))
	{
		if(memcmp(lpHeader, "<svg", 4))
		{
			return FALSE;
		}
	}
#endif

	// gq`FbNs
	return PathMatchSpecA(lpszFileName, "*.svg");
}

/*----------------------------------------------------------------------------
	APIFt@C摜擾
----------------------------------------------------------------------------*/
EXTERN_C INT WINAPI GetPictureInfo(LPVOID lpFileData, LONG lLength, UINT uFlag, SPIPICTUREINFO* lpInfo)
{
	InitSVGEngine();

	HLOCAL hLocalHeader = NULL, hLocalImage = NULL;
	BITMAPINFOHEADER* lpbi;

	// nꂽf[^̏
	switch(uFlag & 0x07)
	{
	default:

		return SPIERROR_NOTIMPLEMENTED;

	case 0: // file

		// lpFileData	: LPCSTR t@C
		// lLength		: ǂݍ݊JnItZbg
		if(!CallSVGEngine(gstrCoreFile.c_str(), CA2T(LPCSTR(lpFileData)), false, hLocalHeader, hLocalImage))
		{
			return SPIERROR_FORMAT;
		}
		if(!hLocalHeader)
		{
			return SPIERROR_FORMAT;
		}
		lpbi = reinterpret_cast<BITMAPINFOHEADER*>(hLocalHeader);
		lpInfo->nWidth = lpbi->biWidth;
		lpInfo->nHeight = lpbi->biHeight;
		lpInfo->nBitCount = lpbi->biBitCount;
		LocalFree(hLocalHeader);
		break;

	case 1: // memory

		return SPIERROR_NOTIMPLEMENTED;
	}

	return SPIERROR_NONE;
}

/*----------------------------------------------------------------------------
	APIFt@C摜ǂݍ
----------------------------------------------------------------------------*/
EXTERN_C INT WINAPI GetPicture(LPVOID lpFileData, LONG lLength, UINT uFlag, HLOCAL* phHeader, HLOCAL* phImage, SPIPROGRESSPROC lpCallback, LPARAM lParam)
{
	InitSVGEngine();

	HLOCAL hLocalHeader = NULL, hLocalImage = NULL;

	// nꂽf[^̏
	switch(uFlag & 0x07)
	{
	default:

		return SPIERROR_NOTIMPLEMENTED;

	case 0: // file

		// lpFileData	: LPCSTR t@C
		// lLength		: ǂݍ݊JnItZbg
		if(!CallSVGEngine(gstrCoreFile.c_str(), CA2T(LPCSTR(lpFileData)), false, hLocalHeader, hLocalImage))
		{
			return SPIERROR_FORMAT;
		}
		if(!hLocalHeader || !hLocalImage)
		{
			return SPIERROR_FORMAT;
		}
		*phHeader = hLocalHeader;
		*phImage = hLocalImage;
		break;

	case 1: // memory

		return SPIERROR_NOTIMPLEMENTED;
	}

	return SPIERROR_NONE;
}

/*----------------------------------------------------------------------------
	APIFt@CTlC
----------------------------------------------------------------------------*/
EXTERN_C INT WINAPI GetPreview(LPVOID lpFileData, LONG lLength, UINT uFlag, HLOCAL* phHeader, HLOCAL* phImage, SPIPROGRESSPROC lpCallback, LPARAM lParam)
{
	return SPIERROR_NOTIMPLEMENTED;
}
